package com.diss.omppapp.services;

import com.diss.omppapp.entities.ClassEntity;
import com.diss.omppapp.entities.UserClassEntity;
import com.diss.omppapp.repositories.ClassEntityRepository;
import com.diss.omppapp.repositories.UserClassEntityRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;
import java.util.Optional;

@Component
public class UserInfoService {

    @Autowired
    UserClassEntityRepository userClassEntityRepository;

    @Autowired
    ClassEntityRepository classEntityRepository;


    public UserInfoService() {
    }

    public List<ClassEntity> getClassList(String id) {
        Optional<List<UserClassEntity>> usersClassesList = userClassEntityRepository.findByUsername(id);
        List<ClassEntity> usersClasses = new ArrayList<>();

        if (!usersClassesList.isPresent()) {
            return new ArrayList<>();
        }

        usersClassesList.get().forEach(e -> {
            Optional<ClassEntity> ce = classEntityRepository.findByClassCode(e.classCode);
            ce.ifPresent(usersClasses::add);
        });

        return usersClasses;
    }

}
